
#include<conio.h>
#include<math.h>
#include "motore2d.h"

#define PI 3.1415926 /* I suppose most of you've heard of this little weazel */
#define KX 2*PI/320     /* KX & KY are constants for the picture drawing */
#define KY 2*PI/200
int filtro;

/* wtsync waits for the vertical retrace
That is when the electron beam jumps back from the bottom right corner
of the screen to the upper left corner of the screen 
This gives us a chance to draw things on the screen, changing the palette and
stuff like that while the electron beam aint drawing */
void wtsync(void)
{
asm     mov     dx,3DAh
WaitVR1:
asm     in      al,dx
asm     test    al,8
asm     jne     WaitVR1
WaitVR2:
asm     in      al,dx
asm     test    al,8
asm     je      WaitVR2
}

/* sets the 256 colours of the palette to the 256 first colours of pal */
void setpal(char*pal)
{
int i;
	outp(0x3c8,0);          /* set colorindex to 0 */
	for(i=0;i<256*3;i++)
	outp(0x3c9,pal[i]);     /* send palett-data to the palett */
}

/* reads the current palette and saves it in the array pal */
void getpal(char*pal)
{
int i;
	outp(0x3c7,0);
	for(i=0;i<256*3;i++)
	pal[i]=inp(0x3c9);
}

/* this function sets up a pal with smooth colorruns between some neat colours
 feel free to change te colours and see what it looks like */
void coolpal(char*pal)
{
int i,r=0,g=0,b=0,col=0;

outp(0x3c8,0);

	for(i=0;i<64;i++)      // BLACK - WHITE
	{
		pal[col++]=r;
		pal[col++]=g;
		pal[col++]=b;
		if(r<63)r++;
		if(g<63)g++;
		if(b<63)b++;
	}
	for(i=0;i<64;i++)      // WHITE - YELLOW
	{
		pal[col++]=r;
		pal[col++]=g;
		pal[col++]=b;
		if(b>0)b--;
	}
	for(i=0;i<64;i++)      // YELLOW - DARK BLUE
	{
		pal[col++]=r;
		pal[col++]=g;
		pal[col++]=b;
		if(r>0)r--;
		if(g>0)g--;
		if(b<63 && i%2==0)b++;
	}
	for(i=0;i<64;i++)      // DARKBLUE - GREEN
	{
		pal[col++]=r;
		pal[col++]=g;
		pal[col++]=b;
		if(g<63)g++;
		if(b>0 && i%2==0)b--;
	}
	for(i=0;i<64;i++)      // GREEN - DARK RED
	{
		pal[col++]=r;
		pal[col++]=g;
		pal[col++]=b;
		if(r<63 && i%2==0)r++;
		if(g>0)g--;
	}
	for(i=0;i<64;i++)      // DARKRED - 63 00 31
	{
		pal[col++]=r;
		pal[col++]=g;
		pal[col++]=b;
		if(r<63 && i%2==0)r++;
		if(b<63 && i%2==0)b++;
	}
	for(i=0;i<64;i++)      // 63 00 31 - 00 31 63
	{
		pal[col++]=r;
		pal[col++]=g;
		pal[col++]=b;
		if(b<63 && i%2==0)b++;
		if(g<63 && i%2==0)g++;
		if(r>0)r--;
	}
	for(i=0;i<64;i++)      // 00 31 63 - BLACK (00 00 00)
	{
		pal[col++]=r;
		pal[col++]=g;
		pal[col++]=b;
		if(b>0)b--;
		if(g>0 && i%2==0)g--;
	}

setpal(pal);                    // set the first 256 colours of pal
}

void rotpal(char*pal,int first, int last)
{
char r,g,b;
int i;

r=pal[first*3 + 0];             //save the first color in r,g,b
g=pal[first*3 + 1];
b=pal[first*3 + 2];

for(i=first*3;i<(last+1)*3;i++) //move all colors down one step (3 bytes)
pal[i]=pal[i+3];

pal[last*3+0]=r;                 //set the last color to r,g,b
pal[last*3+1]=g;
pal[last*3+2]=b;

wtsync();                       //wait for the vertical retrace
setpal(pal);                    //and set the first 256 colours of pal
}

/* putpixel draws a pixel with colour col at (x,y) of the screen */
/* the adress of the coordinate (x,y) is 0A000h:offset */
/* the offset is calculated like this: offset = WIDTH*Y + X */
/* the width of the screen is 320 bytes in mode 13h */
void Putpixel(int x, int y, char col)
{
  asm{
    mov ax,0a000h       //ax = segment adress of the screen
    mov es,ax   //es = A000h
    mov bx,y    //bx = y
    mov di,bx   //di = y
    xchg bh,bl  //bx = 256*y
    shl di,6    //di = 64*y
    add di,bx   //di = (256 + 64)*y = 320*y
    add di,x    //di = 320*y + x
    mov al, col //move the colorbyte to al
    mov [es:di],al      // and move it to the screen
  }
}

/* get pixel is pretty similar to putpixel. 
It reads the colour at (x,y) and returns it */
char getpixel(int x, int y)
{
char col;
  asm{
    mov ax,0a000h
    mov es,ax
    mov bx,y      //bx = y
    mov di,bx     //di = y
    xchg bh,bl    //bx = 256*y
    shl di,6      //di = 64*y
    add di,bx     //di = (256 + 64)*y = 320*y
    add di,x      //di = 320*y + x
    mov al,[es:di]      //move the colour to al
    mov   col,al  //and move it to the char col (a char is one byte)
  }
return col;     //return the color
}

/* sets the graphic mode to mode mode !? */
void setmode(int mode)
{
asm     mov     ax,mode
asm     int     10h
}

void Mat_Function_1(void)
{
int x,y;
char col;
for(x=0;x<320;x++)
{
  for(y=0;y<200;y++)
  {
	col=(sin(x*KX*0.5)-sin(y*KY*0.05))*(127-20)+128;
	col-=(cos(x*KX*0.5)-sin(y*KY*0.05))*(127-20)+128;
  	col+=(cos(x*KX*0.5)*cos(y*KY*0.05))*(127-20)+128;

	putpixel(x,y,col,virtualscreen);
  }
}
}

void Mat_Function_2(void)
{
int x,y;
char col;
for(x=0;x<320;x++)
{
  for(y=0;y<200;y++)
  {
	col=(sin(x*KX*0.5)-sin(y*KY*0.5))*(127-20)+128;
	putpixel(x,y,col,virtualscreen);
  }
}
}

void Mat_Function_3(void)
{
int x,y;
char col;
for(x=0;x<320;x++)
{
  for(y=0;y<200;y++)
  {
	col=(cos(x*KX*0.5)-sin(y*KY*0.5))*(127-20)+128;
	putpixel(x,y,col,virtualscreen);
  }
}
}

void Mat_Function_4(void)
{
int x,y;
char col;
for(x=0;x<320;x++)
{
  for(y=0;y<200;y++)
  {
	col=(cos(x*KX*0.5)*cos(y*KY*0.5))*(127-20)+128;
	putpixel(x,y,col,virtualscreen);
  }
}
}

void Mat_Function_5(void)
{
int x,y;
char col;
for(x=0;x<320;x++)
{
  for(y=0;y<200;y++)
  {
	col=(cos(x*KX/0.5)-cos(y*KY/0.5))*(127-20)+128;
	putpixel(x,y,col,virtualscreen);
  }
}
}
void Mat_Function_6(void)
{
int x,y;
char col;
for(x=0;x<320;x++)
{
  for(y=0;y<200;y++)
  {
	col=(sin(x*KX/4)-cos(y*KY/4))*(127-20)+128;
	putpixel(x,y,col,virtualscreen);
  }
}
}
void Mat_Function_7(void)
{
int x,y;
char col;
for(x=0;x<320;x++)
{
  for(y=0;y<200;y++)
  {
	col=sin(KY*y*0.5)*sin(KX*x*0.5)+128-x+y;

	putpixel(x,y,col,virtualscreen);
  }
}
}


void filtersincos(void)
{
int x,y;
char col;

for(x=0;x<320;x++)
{
for(y=0;y<200;y++)
{
	col=getpixel(x,y);
if(filtro==0)col+=(sin(x*KX/10)*sin(y*KY*10))*20;
if(filtro==1)col+=(sin(x/KX*10)*sin(y*KY*10))*20;
if(filtro==2)col+=(sin(x*y*KX/10)*sin(y*x*KY*10))*20;
if(filtro==3)col+=(sin(x*KX/3)*sin(y*KY*3))*20;
if(filtro==4)col+=(sin(x*KX*15)*sin(y*KY*15))*20;
	putpixel(x,y,col,virtualscreen);
}
}
if(filtro==4)filtro=0;
}


void main(void)
{
if(create_screen(1)==1)return;
char pal[512*3];
filtro=0;

printf("PLASMA EFFECT coded by NURBS(Cattai Marco) - ChristMAS 1998\n");
printf("Function:\n Key(1):Filters\n Key(2 to 9):Mathematical Function\n");
printf("Press a key to continue...");
getch();
setmode(0x0013);


coolpal(pal);
wtsync();
Mat_Function_2();
copyscr(physicalscreen,virtualscreen);
pcx("n98.pcx");
copyimmtrasp(physicalscreen,virtualscreen,319,199,0,0,0,0,0);


int filter=0;
int tasto=0;
do
{
        if(kbhit())
	{
	tasto=getch();

                switch(tasto){
                case '1':
                	filtro++;
                	if(filter==0)
			{
			filtersincos();
                        copyscr(physicalscreen,virtualscreen);
			pcx("n98.pcx");
			copyimmtrasp(physicalscreen,virtualscreen,319,199,0,0,0,0,0);
                        }
                        filter=1;
                	break;
                case '2':
			Mat_Function_1();
			copyscr(physicalscreen,virtualscreen);
pcx("n98.pcx");
copyimmtrasp(physicalscreen,virtualscreen,319,199,0,0,0,0,0);
                        filter=0;
                	break;
                case '3':
			Mat_Function_2();
			copyscr(physicalscreen,virtualscreen);
pcx("n98.pcx");
copyimmtrasp(physicalscreen,virtualscreen,319,199,0,0,0,0,0);
                        filter=0;
                	break;
                case '4':
			Mat_Function_3();
			copyscr(physicalscreen,virtualscreen);
pcx("n98.pcx");
copyimmtrasp(physicalscreen,virtualscreen,319,199,0,0,0,0,0);
                        filter=0;
                	break;
                case '5':
			Mat_Function_4();
			copyscr(physicalscreen,virtualscreen);
pcx("n98.pcx");
copyimmtrasp(physicalscreen,virtualscreen,319,199,0,0,0,0,0);
                        filter=0;
                	break;
                case '6':
			Mat_Function_5();
			copyscr(physicalscreen,virtualscreen);
pcx("n98.pcx");
copyimmtrasp(physicalscreen,virtualscreen,319,199,0,0,0,0,0);
                        filter=0;
                	break;
                case '7':
			Mat_Function_6();
			copyscr(physicalscreen,virtualscreen);
pcx("n98.pcx");
copyimmtrasp(physicalscreen,virtualscreen,319,199,0,0,0,0,0);
                        filter=0;
                	break;
                case '8':
			Mat_Function_7();
			copyscr(physicalscreen,virtualscreen);
                        filter=0;
pcx("n98.pcx");
copyimmtrasp(physicalscreen,virtualscreen,319,199,0,0,0,0,0);
                	break;
                case '9':
                        pcx("n98.pcx");
			copyscr(physicalscreen,virtualscreen);
                        filter=1;
                	break;

                }
        }
	rotpal(pal,1,511);

}while(tasto!=27);

setmode(3);              //get back into textmode

}
